unit About;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, FileCtrl, verinfo, ExtCtrls;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    OKButton: TButton;
    lblCompany: TLabel;
    lblComments: TLabel;
    lblProduct: TLabel;
    lblVersion: TLabel;
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    VerInfoRes: TVerInfoRes;
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  VerInfoRes := TVerInfoRes.Create(Application.ExeName);
end;  // FormCreate.

procedure TAboutBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VerInfoRes.Free;
end;  // FormClose.

procedure TAboutBox.OKButtonClick(Sender: TObject);
begin
  Close;
end;  // OKButtonClick.

procedure TAboutBox.FormShow(Sender: TObject);
var
  VerString: String;
//  i: integer;
//  sFFlags: String;
begin
//  VerString := VerInfoRes.GetPreDefKeyString(TVerInfoType(ord(viCompanyName)));
//  lblCompany.Caption := VerString;

//  VerString := VerInfoRes.GetPreDefKeyString(TVerInfoType(ord(viFileVersion)));
  VerString := VerInfoRes.GetPreDefKeyString(TVerInfoType(ord(viFileVersion)));
  lblVersion.Caption := VerString;
  VerString := VerInfoRes.GetPreDefKeyString(TVerInfoType(ord(viCompanyName)));
  lblCompany.Caption := VerString;
  VerString := VerInfoRes.GetPreDefKeyString(TVerInfoType(ord(viComments)));
  lblComments.Caption := VerString;
{
  for i := ord(viCompanyName) to ord(viComments) do begin
    VerString := VerInfoRes.GetPreDefKeyString(TVerInfoType(i));
    if VerString <> '' then
      AddListViewItem(VerNameArray[TVerInfoType(i)], VerString, nil,
      lvVersionInfo);
  end;
  VerString := VerInfoRes.GetUserDefKeyString('Author');
  if VerString <> EmptyStr then
    AddListViewItem('Author', VerString, nil, lvVersionInfo);
  AddListViewItem('File Version', VerInfoRes.FileVersion, nil, lvVersionInfo);
  AddListViewItem('Product Version', VerInfoRes.ProductVersion, nil,
    lvVersionInfo);
  for i := 0 to VerInfoRes.FileFlags.Count - 1 do begin
    if i <> 0 then
      sFFlags := SFFlags+', ';
    sFFlags := SFFlags+VerInfoRes.FileFlags[i];
  end;

  AddListViewItem('File Flags',SFFlags, nil, lvVersionInfo);
  AddListViewItem('Operating System', VerINfoRes.FileOS, nil, lvVersionInfo);
}
end;  // FormShow.

end.

