unit DCEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Mask, ToolEdit, CurrEdit, RxLookup, Db, DBTables,
  DBCtrls;

type
  TDCEditForm = class(TForm)
    lblServiceID: TLabel;
    btnCancel: TButton;
    btnSave: TButton;
    edtServiceID: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
    nWindow: Integer;  // Array element in MainForm's (Public) array aWinForm.
    lDCDetail : boolean;
    sOldServiceID : string;
    sBatchID : string;
  protected
    // These procedures give external access to the form variables.
    procedure SetWindowNum(Value: Integer);
    procedure SetBatchID(Value: integer);
    function GetBatchID: integer;
    procedure SetServiceID(Value: string);
    function GetServiceID: string;
    procedure SetDCDetail(Value: boolean);
    function GetDCDetail: boolean;
  published
    // Used to access nWindow.
    property ActiveWindowNum: Integer
             read nWindow write SetWindowNum default -1;
    // Used to access window parameters for remote access.
    property BatchID: integer read GetBatchID write SetBatchID;
    property ServiceID: string read GetServiceID write SetServiceID;
    property DCdetail: boolean read GetDCDetail write SetDCDetail;
  public
    { Public declarations }
  end;

var
  DCEditForm: TDCEditForm;

implementation

{$R *.DFM}

uses
  DataMod, Main;

procedure TDCEditForm.FormCreate(Sender: TObject);
begin
  lDCDetail := False;
end;

procedure TDCEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Indicate that this form is closed.
  if (nWindow <> -1) then begin
    // It has been set by the calling program.
    aWinForm[nWindow] := False;   // Value of nWindow set by calling program.
  end;
end;    // procedure FormClose(Sender; Action).

procedure TDCEditForm.SetWindowNum(Value: Integer);
// This procedure allows the calling procedure to identify this form.
begin
  if (nWindow <> Value) then begin
    if (Value > -1) and (Value < WINNUM) then begin
      nWindow := Value;
    end
    else begin
      nWindow := -1;
    end;
  end;  // if nWindow <> Value then.
end;  // procedure SetWindowNum(Value: Integer).

procedure TDCEditForm.SetBatchID(Value: integer);
begin
  sBatchID := IntToStr(Value);
end;    // SetBatchID.

function TDCEditForm.GetBatchID: integer;
begin
  Result := StrToInt(sBatchID);
end;    // GetBatchID.

procedure TDCEditForm.SetServiceID(Value: string);
begin
  sOldServiceID := Value;
  edtServiceID.Text := sOldServiceID;
end;    // SetServiceID.

function TDCEditForm.GetServiceID: string;
begin
  Result := edtServiceID.Text;
end;    // GetServiceID.

procedure TDCEditForm.SetDCDetail(Value: boolean);
begin
  lDCDetail := Value;
end;    // procedure SetDCDetail().

function TDCEditForm.GetDCDetail: boolean;
begin
  Result := lDCDetail;
end;    // procedure GetDCDetail().

procedure TDCEditForm.btnSaveClick(Sender: TObject);
var
  slManual : TStringList;
  sTemp : string;
  sServiceID : string;
  qSave : TQuery;
begin
  sServiceID := Trim(edtServiceID.Text);
  if (sServiceID <> sOldServiceID) then
    sTemp := 'SET ServiceID = '''+ sServiceID +'''';
  if (Length(sTemp) > 0) then begin
    slManual := TStringList.Create;
    slManual.Add('UPDATE tDataCollection');
    slManual.Add(sTemp);
    slManual.Add('WHERE BatchID = '+sBatchID);
    slManual.Add('AND ServiceID LIKE '''+sOldServiceID+'''');
    qSave := MainForm.qry;
    qSave.SQL := slManual;
    qSave.ExecSQL;
    slManual.Free;
  end;  // if (Length(sTemp) > 0) then begin.
  ModalResult := mrOk;
end;  // btnSaveClick.

end.
