unit DataMod;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, inifiles;

type
  TDM = class(TDataModule)
    dbPPdata: TDatabase;
    dbQuetzal: TDatabase;
    dbQuote: TDatabase;
    procedure DBSaccLogin(Database: TDatabase; LoginParams: TStrings);
    procedure DMCreate(Sender: TObject);
  private
    { Private declarations }
    function StringCode(const CodedWord: String): String;
  public
    { Public declarations }
  end;

var
  DM: TDM;

implementation

uses
  LoginFrm;
  
{$R *.DFM}

function TDM.StringCode(const CodedWord: String) : String;
var
  CodedWordLength : Integer;
  CodedWordCharNumber : Integer;
  AsciiValue : Integer;
  DecodedWord : string;
begin
  CodedWordLength := Length( CodedWord );
  DecodedWord := '';
  for CodedWordCharNumber := 1 to CodedWordLength do
    begin
    // Get the ASCII value of the next character in the passed string.
    AsciiValue := Ord( CodedWord[ CodedWordCharNumber ] );
    // XOR the ASCII code.
    AsciiValue := (AsciiValue xor (-1));
    // Convert the ASCII code to a character, add to the result string.
    DecodedWord := DecodedWord + Chr( AsciiValue );
    end;
  Result := DecodedWord;
end;


procedure TDM.DBSaccLogin(Database: TDatabase;
  LoginParams: TStrings);
var
  KeyString : string;
begin
  KeyString := Chr(147)+Chr(141)+Chr(145)+Chr(146)+
                       Chr(143)+Chr(135);
  LoginParams.Values['USERNAME'] := 'ibmsys';
  KeyString := StringCode(KEYSTRING);
  LoginParams.Values['PASSWORD'] := KeyString;          
end;


procedure TDM.DMCreate(Sender: TObject);
var
  NewPPIniFile : TIniFile;
  IniFileName : string;
  LoginParams : TStringList;
  sDSN : string;
  sUserName : string;
  sPassword : string;
  LoginForm : TLoginForm;
//  sTemp : string;
//  nStr : integer;
begin
  LoginParams := TStringList.Create;
  IniFileName := LowerCase(ParamStr(0));
  IniFileName := Copy(IniFileName,1,Length(IniFileName)-3) + 'ini';
  NewPPIniFile := TIniFile.Create(IniFileName);
  // dbPPdata - SQLPP (most common) database.
  with NewPPIniFile do begin
    sDSN := ReadString('DBconnection','PPDSN', '');
    sUserName := ReadString('DBconnection','ur', '');
    sPassword := ReadString('DBconnection','pd', '');
  end;
  // True in the following = Startup call only.
  if (Length(sDSN) = 0) or (Length(sUserName) = 0)
    or (Length(sPassword) = 0) then begin
    if (Length(sDSN) = 0) then sDSN := dbPPdata.AliasName;
    LoginForm := TLoginForm.Create(SELF);
    LoginForm.GetLoginParams('PreProcessor',True,sDSN,LoginParams);
    LoginForm.Free;
    sUserName := LoginParams.Values['USER NAME'];
    sPassword := LoginParams.Values['PASSWORD'];
    with NewPPIniFile do begin
      if (Length(sDSN)>0) then
        WriteString('DBconnection','PPDSN',sDSN);
      if (Length(sUserName)>0) then
        WriteString('DBconnection','ur',sUserName);
      if (Length(sPassword)>0) then
        WriteString('DBconnection','pd',sPassword);
    end;  // with NewPPIniFile do begin.
  end;  // One or more parameters missing.
  if (Length(sUserName) > 0) and (Length(sPassword) > 0) then begin
    LoginParams.Add('USER NAME='+sUserName);
    LoginParams.Add('PASSWORD='+sPassword);
    if dbPPdata.Connected then dbPPdata.Connected := False;
    dbPPdata.AliasName := sDSN;
    dbPPdata.Params := LoginParams;
    dbPPdata.LoginPrompt := False;
  end;  // One or more parameters missing.
  dbPPdata.Connected := True;
  // dbQuetzal - Quetzal database.
  sDSN := '';
  sUserName := '';
  sPassword := '';
  with NewPPIniFile do begin
    sDSN := ReadString('DBconnection','QuetzalDSN', '');
    sUserName := ReadString('DBconnection','urq', '');
    sPassword := ReadString('DBconnection','pdq', '');
  end;
  // True in the following = Startup call only.
  if (Length(sDSN) = 0) or (Length(sUserName) = 0)
    or (Length(sPassword) = 0) then begin
    if (Length(sDSN) = 0) then sDSN := dbQuetzal.AliasName;
    LoginForm := TLoginForm.Create(SELF);
    LoginForm.GetLoginParams('QuetzalSC',True,sDSN,LoginParams);
    LoginForm.Free;
    sUserName := LoginParams.Values['USER NAME'];
    sPassword := LoginParams.Values['PASSWORD'];
    with NewPPIniFile do begin
      if (Length(sDSN)>0) then
        WriteString('DBconnection','QuetzalDSN',sDSN);
      if (Length(sUserName)>0) then
        WriteString('DBconnection','urq',sUserName);
      if (Length(sPassword)>0) then
        WriteString('DBconnection','pdq',sPassword);
    end;  // with NewPPIniFile do begin.
  end;  // One or more parameters missing.
  if (Length(sUserName) > 0) and (Length(sPassword) > 0) then begin
    LoginParams.Clear;
    LoginParams.Add('USER NAME='+sUserName);
    LoginParams.Add('PASSWORD='+sPassword);
    if dbQuetzal.Connected then dbQuetzal.Connected := False;
    dbQuetzal.AliasName := sDSN;
    dbQuetzal.Params := LoginParams;
    dbQuetzal.LoginPrompt := False;
  end;  // One or more parameters missing.
//  dbQuetzal.Connected := True;
  // dbQuote - Quote System database.
  sDSN := '';
  sUserName := '';
  sPassword := '';
  with NewPPIniFile do begin
    sDSN := ReadString('DBconnection','QuoteDSN', '');
    sUserName := ReadString('DBconnection','urs', '');
    sPassword := ReadString('DBconnection','pds', '');
  end;
  // True in the following = Startup call only.
  if (Length(sDSN) = 0) or (Length(sUserName) = 0)
    or (Length(sPassword) = 0) then begin
    if (Length(sDSN) = 0) then sDSN := dbQuote.AliasName;
    LoginForm := TLoginForm.Create(SELF);
    LoginForm.GetLoginParams('Quote System',True,sDSN,LoginParams);
    LoginForm.Free;
    sUserName := LoginParams.Values['USER NAME'];
    sPassword := LoginParams.Values['PASSWORD'];
    with NewPPIniFile do begin
      if (Length(sDSN)>0) then
        WriteString('DBconnection','QuoteDSN',sDSN);
      if (Length(sUserName)>0) then
        WriteString('DBconnection','urs',sUserName);
      if (Length(sPassword)>0) then
        WriteString('DBconnection','pds',sPassword);
    end;  // with NewPPIniFile do begin.
  end;  // One or more parameters missing.
  if (Length(sUserName) > 0) and (Length(sPassword) > 0) then begin
    LoginParams.Clear;
    LoginParams.Add('USER NAME='+sUserName);
    LoginParams.Add('PASSWORD='+sPassword);
    if dbQuote.Connected then dbQuote.Connected := False;
    dbQuote.AliasName := sDSN;
    dbQuote.Params := LoginParams;
    dbQuote.LoginPrompt := False;
  end;  // One or more parameters missing.
//  dbQuote.Connected := True;
  // Done - Logged into All databases.
  LoginParams.Free;
  NewPPIniFile.Free;
end;

end.
