unit MultiManual;

interface

uses
  db, dbTables, SysUtils, forms;

procedure WriteMultiManualToDC(const nBatchID: integer);

implementation

uses
  DateFunctions, DataMod, Main, MyMessage;
  
procedure WriteMultiManualToDC(const nBatchID: integer);
var
  qry : TQuery;
  MessageForm : TMessagesForm;
  sBatchID : string;
  sSeed : string;
  sManualRentID : string;
  sManualCallID : string;
  sManualOtherID : string;
  sBatchTypeID : string;
  sFromDate : string;
  sToDate : string;
begin
  sSeed := '1';
  MessageForm := TMessagesForm.Create(MainForm);
  MessageForm.Caption := 'Creating Multiple Manual Charges ...';
  MessageForm.Msg.Caption := 'Reading variables ...';
  MessageForm.Show;
  MainForm.ProcessWinMessages;
  sBatchID := IntToStr(nBatchID);
  qry := TQuery.Create(nil);
  with qry do begin
    DatabaseName := 'dbPPdata';
    // Make sure the temporary database does not exist at the start..
    SQL.Add('if exists (select * from dbo.sysobjects '+
      'where id = object_id(N''[dbo].[tDCMM_Temprjc2006]'') and '+
      'OBJECTPROPERTY(id, N''IsUserTable'') = 1)');
    SQL.Add('drop table [dbo].[tDCMM_Temprjc2006]');
//    SQL.Add('GO');
    ExecSQL;
    Close;
    // Now get the TransactionTypeID values.
    SQL.Clear;
    SQL.Add('SELECT tTransactionType.id, tTransactionGroup.Description AS "GroupName"');
    SQL.Add('FROM tTransactionType');
    SQL.Add('LEFT JOIN tTransactionGroup '+
      'ON tTransactionType.TransactionGroupID = tTransactionGroup.ID');
    SQL.Add('WHERE tTransactionType.Description LIKE ''Manual%''');
    Open;
    sManualRentID := 'NULL';
    sManualCallID := 'NULL';
    sManualOtherID := 'NULL';
    if not (Bof and Eof) then begin
      while not Eof do begin
        if (FieldValues['GroupName'] = 'RENT') then
          sManualRentID := IntToStr(FieldValues['id'])
        else if (FieldValues['GroupName'] = 'CALL') then
          sManualCallID := IntToStr(FieldValues['id'])
        else if (FieldValues['GroupName'] = 'OTHER') then
          sManualOtherID := IntToStr(FieldValues['id']);
        Next;
      end;
    end;
    Close;
//  end;  // qry.
  // Get Batch information.
//  with qry do begin
    SQL.Clear;
    SQL.Add('SELECT tBatch.BatchTypeID, tBatch.BatchStartDate, '+
      'tBatch.BatchEndDate');
    SQL.Add('FROM tBatch');
    SQL.Add('WHERE tBatch.ID = '+sBatchID);
    Open;
    if not (Bof and Eof) then begin
      sBatchTypeID := VarToStr(FieldValues['BatchTypeID']);
      sFromDate := FormattedDateString(FieldByName('BatchStartDate').AsDateTime);
      sToDate := FormattedDateString(FieldByName('BatchEndDate').AsDateTime);
    end;
    Close;
//  end;  // qry.

  MessageForm.Msg.Caption := 'Saving Rent to tDataCollection ...';
  MessageForm.Show;
  MainForm.ProcessWinMessages;

  // Now, save rent charges to the tDataCollection table.
//  with qry do begin
    SQL.Clear;
    SQL.Add('SELECT IDENTITY(int,'+sSeed+',1) AS "SequNo", ServiceID, GSTFlag, ');
    SQL.Add('AmountExGST, GSTAmount, AmountIncGST, ');
    SQL.Add('FromDate, ToDate, RateDescription, ');
    SQL.Add('BatchID, TransactionTypeID');
    SQL.Add('INTO tDCMM_Temprjc2006');
    SQL.Add('FROM (SELECT MM2.ServiceID, '+
      '(CASE WHEN MM2.GSTAmount = 0 THEN ''N'' ELSE ''Y'' END) AS "GSTFlag",');
    SQL.Add(' MM2.AmountExGST, MM2.GSTAmount, '+
      '(MM2.AmountExGST + MM2.GSTAmount) AS "AmountIncGST",');
    SQL.Add(' MM2.FromDate, MM2.ToDate, MM2.RateDescription,');
    SQL.Add('('+sBatchID+') AS "BatchID",'+
      ' ('+sManualRentID+') AS "TransactionTypeID"');
    SQL.Add('FROM (SELECT MM1.Rent AS "AmountExGST",');
    SQL.Add(' (MM1.Rent / MM1.Total * MM1.GSTAmt) AS "GSTAmount", MM1.*');
    SQL.Add('FROM (SELECT (MM.Rent + MM.Call + MM.Other) AS "Total", MM.*');
    SQL.Add('FROM (SELECT MMD.ServiceID,');
    SQL.Add(' (CASE WHEN MMD.Rent IS NULL THEN 0 ELSE MMD.Rent END) AS "Rent",');
    SQL.Add(' (CASE WHEN MMD.Call IS NULL THEN 0 ELSE MMD.Call END) AS "Call",');
    SQL.Add(' (CASE WHEN MMD.Other IS NULL THEN 0 ELSE MMD.Other END) AS "Other",');
    SQL.Add(' (CASE WHEN MMD.GSTAmt IS NULL THEN 0 ELSE MMD.GSTAmt END) AS "GSTAmt",');
    SQL.Add(' (CASE WHEN (MMD.FromDate IS NULL OR '+
      'DATALENGTH(MMD.FromDate) <> 10) THEN NULL');
    SQL.Add('       ELSE MMD.FromDate END) AS "FromDate",');
    SQL.Add(' (CASE WHEN (MMD.ToDate IS NULL OR '+
      'DATALENGTH(MMD.ToDate) <> 10) THEN NULL');
    SQL.Add('       ELSE MMD.ToDate END) AS "ToDate",');
    SQL.Add(' (CASE WHEN (MMD.RateDescription IS NULL OR '+
      'DATALENGTH(LTRIM(RTRIM(MMD.RateDescription))) = 0) THEN NULL');
    SQL.Add('       ELSE LTRIM(RTRIM(MMD.RateDescription)) END) AS "RateDescription"');
    SQL.Add('FROM tMultiManualData AS MMD');
    SQL.Add('WHERE MMD.BatchTypeID = '+sBatchTypeID+') AS MM) AS MM1');
    SQL.Add('WHERE MM1.Rent IS NOT NULL');
    SQL.Add('AND MM1.Rent <> 0) AS MM2) AS DCMM');
    ExecSQL;
    SQL.Clear;
    SQL.Add('SELECT SequNo');
    SQL.Add('FROM tDCMM_Temprjc2006');
    SQL.Add('ORDER BY SequNo DESC');
    Open;
    if (Bof and Eof) then begin
      Close;
    end
    else begin
      sSeed := VarToStr(FieldValues['SequNo']+1);
      if (Length(sSeed) = 0) then sSeed := '1';
      Close;
      SQL.Clear;
      SQL.Add('INSERT INTO tDataCollection');
      SQL.Add('(SequenceNo, ServiceID, GSTFlag, AmountExGST,');
      SQL.Add(' GSTAmount, AmountIncGST, FromDate, ToDate,');
      SQL.Add(' RateDescription,');
      SQL.Add(' BatchID, TransactionTypeID)');
      SQL.Add('SELECT CAST(SequNo AS varchar) AS "SequenceNo", '+
        'ServiceID, GSTFlag, AmountExGST,');
      SQL.Add(' GSTAmount, AmountIncGST, FromDate, ToDate,');
      SQL.Add(' RateDescription,');
      SQL.Add(' BatchID, TransactionTypeID');
      SQL.Add('FROM tDCMM_Temprjc2006');
      ExecSQL;                 // Import data into tDataCollection.
    end;  // not empty table.
    SQL.Clear;
    SQL.Add('DROP TABLE tDCMM_Temprjc2006');
    ExecSQL;                 // Drop the temporary table.
//  end;  // qry.

  MessageForm.Msg.Caption := 'Saving Call to tDataCollection ...';
  MainForm.ProcessWinMessages;
  // Save call charges to the tDataCollection table.
//  with qry do begin
    SQL.Clear;
    SQL.Add('SELECT IDENTITY(int,'+sSeed+',1) AS "SequNo", ServiceID, GSTFlag, ');
    SQL.Add('AmountExGST, GSTAmount, AmountIncGST, ');
    SQL.Add('FromDate, ToDate, RateDescription, ');
    SQL.Add('BatchID, TransactionTypeID');
    SQL.Add('INTO tDCMM_Temprjc2006');
    SQL.Add('FROM (SELECT MM2.ServiceID, '+
      '(CASE WHEN MM2.GSTAmount = 0 THEN ''N'' ELSE ''Y'' END) AS "GSTFlag",');
    SQL.Add(' MM2.AmountExGST, MM2.GSTAmount, '+
      '(MM2.AmountExGST + MM2.GSTAmount) AS "AmountIncGST",');
    SQL.Add(' MM2.FromDate, MM2.ToDate, MM2.RateDescription,');
    SQL.Add('('+sBatchID+') AS "BatchID",'+
      ' ('+sManualCallID+') AS "TransactionTypeID"');
    SQL.Add('FROM (SELECT MM1.Call AS "AmountExGST",');
    SQL.Add(' (MM1.Call / MM1.Total * MM1.GSTAmt) AS "GSTAmount", MM1.*');
    SQL.Add('FROM (SELECT (MM.Rent + MM.Call + MM.Other) AS "Total", MM.*');
    SQL.Add('FROM (SELECT MMD.ServiceID,');
    SQL.Add(' (CASE WHEN MMD.Rent IS NULL THEN 0 ELSE MMD.Rent END) AS "Rent",');
    SQL.Add(' (CASE WHEN MMD.Call IS NULL THEN 0 ELSE MMD.Call END) AS "Call",');
    SQL.Add(' (CASE WHEN MMD.Other IS NULL THEN 0 ELSE MMD.Other END) AS "Other",');
    SQL.Add(' (CASE WHEN MMD.GSTAmt IS NULL THEN 0 ELSE MMD.GSTAmt END) AS "GSTAmt",');
    SQL.Add(' (CASE WHEN (MMD.FromDate IS NULL OR '+
      'DATALENGTH(MMD.FromDate) <> 10) THEN NULL');
    SQL.Add('       ELSE MMD.FromDate END) AS "FromDate",');
    SQL.Add(' (CASE WHEN (MMD.ToDate IS NULL OR '+
      'DATALENGTH(MMD.ToDate) <> 10) THEN NULL');
    SQL.Add('       ELSE MMD.ToDate END) AS "ToDate",');
    SQL.Add(' (CASE WHEN (MMD.RateDescription IS NULL OR '+
      'DATALENGTH(LTRIM(RTRIM(MMD.RateDescription))) = 0) THEN NULL');
    SQL.Add('       ELSE LTRIM(RTRIM(MMD.RateDescription)) END) AS "RateDescription"');
    SQL.Add('FROM tMultiManualData AS MMD');
    SQL.Add('WHERE MMD.BatchTypeID = '+sBatchTypeID+') AS MM) AS MM1');
    SQL.Add('WHERE MM1.Call IS NOT NULL');
    SQL.Add('AND MM1.Call <> 0) AS MM2) AS DCMM');
    ExecSQL;
    SQL.Clear;
    SQL.Add('SELECT SequNo');
    SQL.Add('FROM tDCMM_Temprjc2006');
    SQL.Add('ORDER BY SequNo DESC');
    Open;
    if (Bof and Eof) then begin
      Close;
    end
    else begin
      sSeed := VarToStr(FieldValues['SequNo']+1);
      if (Length(sSeed) = 0) then sSeed := '1';
      Close;
      SQL.Clear;
      SQL.Add('INSERT INTO tDataCollection');
      SQL.Add('(SequenceNo, ServiceID, GSTFlag, AmountExGST,');
      SQL.Add(' GSTAmount, AmountIncGST, FromDate, ToDate,');
      SQL.Add(' RateDescription,');
      SQL.Add(' BatchID, TransactionTypeID)');
      SQL.Add('SELECT CAST(SequNo AS varchar) AS "SequenceNo", '+
        'ServiceID, GSTFlag, AmountExGST,');
      SQL.Add(' GSTAmount, AmountIncGST, FromDate, ToDate,');
      SQL.Add(' RateDescription,');
      SQL.Add(' BatchID, TransactionTypeID');
      SQL.Add('FROM tDCMM_Temprjc2006');
      ExecSQL;                 // Import data into tDataCollection.
    end;  // not empty table.
    SQL.Clear;
    SQL.Add('DROP TABLE tDCMM_Temprjc2006');
    ExecSQL;                 // Drop the temporary table.
//  end;  // qry.

  MessageForm.Msg.Caption := 'Saving Other to tDataCollection ...';
//  MessageForm.Show;
  MainForm.ProcessWinMessages;
  // Save other charges to the tDataCollection table.
//  with qry do begin
    SQL.Clear;
    SQL.Add('SELECT IDENTITY(int,'+sSeed+',1) AS "SequNo", ServiceID, GSTFlag, ');
    SQL.Add('AmountExGST, GSTAmount, AmountIncGST, ');
    SQL.Add('FromDate, ToDate, RateDescription, ');
    SQL.Add('BatchID, TransactionTypeID');
    SQL.Add('INTO tDCMM_Temprjc2006');
    SQL.Add('FROM (SELECT MM2.ServiceID, '+
      '(CASE WHEN MM2.GSTAmount = 0 THEN ''N'' ELSE ''Y'' END) AS "GSTFlag",');
    SQL.Add(' MM2.AmountExGST, MM2.GSTAmount, '+
      '(MM2.AmountExGST + MM2.GSTAmount) AS "AmountIncGST",');
    SQL.Add(' MM2.FromDate, MM2.ToDate, MM2.RateDescription,');
    SQL.Add('('+sBatchID+') AS "BatchID",'+
      ' ('+sManualOtherID+') AS "TransactionTypeID"');
    SQL.Add('FROM (SELECT MM1.Other AS "AmountExGST",');
    SQL.Add(' (MM1.Other / MM1.Total * MM1.GSTAmt) AS "GSTAmount", MM1.*');
    SQL.Add('FROM (SELECT (MM.Rent + MM.Call + MM.Other) AS "Total", MM.*');
    SQL.Add('FROM (SELECT MMD.ServiceID,');
    SQL.Add(' (CASE WHEN MMD.Rent IS NULL THEN 0 ELSE MMD.Rent END) AS "Rent",');
    SQL.Add(' (CASE WHEN MMD.Call IS NULL THEN 0 ELSE MMD.Call END) AS "Call",');
    SQL.Add(' (CASE WHEN MMD.Other IS NULL THEN 0 ELSE MMD.Other END) AS "Other",');
    SQL.Add(' (CASE WHEN MMD.GSTAmt IS NULL THEN 0 ELSE MMD.GSTAmt END) AS "GSTAmt",');
    SQL.Add(' (CASE WHEN (MMD.FromDate IS NULL OR '+
      'DATALENGTH(MMD.FromDate) <> 10) THEN NULL');
    SQL.Add('       ELSE MMD.FromDate END) AS "FromDate",');
    SQL.Add(' (CASE WHEN (MMD.ToDate IS NULL OR '+
      'DATALENGTH(MMD.ToDate) <> 10) THEN NULL');
    SQL.Add('       ELSE MMD.ToDate END) AS "ToDate",');
    SQL.Add(' (CASE WHEN (MMD.RateDescription IS NULL OR '+
      'DATALENGTH(LTRIM(RTRIM(MMD.RateDescription))) = 0) THEN NULL');
    SQL.Add('       ELSE LTRIM(RTRIM(MMD.RateDescription)) END) AS "RateDescription"');
    SQL.Add('FROM tMultiManualData AS MMD');
    SQL.Add('WHERE MMD.BatchTypeID = '+sBatchTypeID+') AS MM) AS MM1');
    SQL.Add('WHERE MM1.Other IS NOT NULL');
    SQL.Add('AND MM1.Other <> 0) AS MM2) AS DCMM');
    ExecSQL;
    SQL.Clear;
    SQL.Add('SELECT SequNo');
    SQL.Add('FROM tDCMM_Temprjc2006');
    SQL.Add('ORDER BY SequNo DESC');
    Open;
    if (Bof and Eof) then begin
      Close;
    end
    else begin
      sSeed := VarToStr(FieldValues['SequNo']+1);
      if (Length(sSeed) = 0) then sSeed := '1';
      Close;
      SQL.Clear;
      SQL.Add('INSERT INTO tDataCollection');
      SQL.Add('(SequenceNo, ServiceID, GSTFlag, AmountExGST,');
      SQL.Add(' GSTAmount, AmountIncGST, FromDate, ToDate,');
      SQL.Add(' RateDescription,');
      SQL.Add(' BatchID, TransactionTypeID)');
      SQL.Add('SELECT CAST(SequNo AS varchar) AS "SequenceNo", '+
        'ServiceID, GSTFlag, AmountExGST,');
      SQL.Add(' GSTAmount, AmountIncGST, FromDate, ToDate,');
      SQL.Add(' RateDescription,');
      SQL.Add(' BatchID, TransactionTypeID');
      SQL.Add('FROM tDCMM_Temprjc2006');
      ExecSQL;                 // Import data into tDataCollection.
    end;  // not empty table.
    SQL.Clear;
    SQL.Add('DROP TABLE tDCMM_Temprjc2006');
    ExecSQL;                 // Drop the temporary table.
//  end;  // qry.
  // Now clean up the base table - remove invalid datetime data.
//  with qry do begin
    // FromDate.
    SQL.Clear;
    SQL.Add('UPDATE tMultiManualData');
    SQL.Add('SET FromDate = NULL');
    SQL.Add('WHERE BatchTypeID = '+sBatchTypeID);
    SQL.Add('AND FromDate IS NOT NULL');
    SQL.Add('AND DATALENGTH(FromDate) <> 10');
    ExecSQL;
    // ToDate.
    SQL.Clear;
    SQL.Add('UPDATE tMultiManualData');
    SQL.Add('SET ToDate = NULL');
    SQL.Add('WHERE BatchTypeID = '+sBatchTypeID);
    SQL.Add('AND ToDate IS NOT NULL');
    SQL.Add('AND DATALENGTH(ToDate) <> 10');
    ExecSQL;
  end;  // qry.
  MessageForm.Close;
  MessageForm.Free;
end;  // WriteMultiManualToDC.

end.
